﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _7404_High
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }

        private void 调整行高自定义方法ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.Rows[fpSpread1.ActiveSheet.ActiveRowIndex].Height = GetRowBestHeight(fpSpread1.ActiveSheet.ActiveRowIndex);
        }



        private void 调整行高标准方法ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.Rows[fpSpread1.ActiveSheet.ActiveRowIndex].Height = fpSpread1.ActiveSheet.GetPreferredRowHeight(fpSpread1.ActiveSheet.ActiveRowIndex, false, false);
        }

        private float GetRowBestHeight(int viRow)
        {
            Graphics vgphGraphics = fpSpread1.CreateGraphics();
            int iLoop = 0;
            float fBestHeight = 0;

            SizeF sfBestSize = default(SizeF);
            float fWidth = 0;

            while ((iLoop < fpSpread1.ActiveSheet.ColumnCount - 1))
            {
                fWidth = 0;
                for (int iTemp = 0; iTemp <= (fpSpread1.ActiveSheet.Cells[viRow, iLoop].ColumnSpan - 1); iTemp++)
                {
                    fWidth += fpSpread1.ActiveSheet.Columns[iLoop + iTemp].Width;
                }
                sfBestSize = vgphGraphics.MeasureString(fpSpread1.ActiveSheet.Cells[viRow, iLoop].Text, fpSpread1.Font, Convert.ToInt32(fWidth));
                if (sfBestSize.Height > fBestHeight)
                {
                    fBestHeight = sfBestSize.Height;
                }
                iLoop += fpSpread1.ActiveSheet.Cells[viRow, iLoop].ColumnSpan;

            }
            return fBestHeight;
        }
    }
}
